Index: libabac/abac_c.h
===================================================================
--- libabac/abac_c.h	(revision 2e9455f11fea0205b8b4b1306b5d0804cda72e10)
+++ libabac/abac_c.h	(revision 2e9455f11fea0205b8b4b1306b5d0804cda72e10)
@@ -0,0 +1,70 @@
+#ifndef __ABAC_C_H__
+#define __ABAC_C_H__
+
+/* export visible routines from abac_c.c */
+extern void abac_constraint_add_integer_max(abac_condition_t *cond,int val);
+extern void abac_constraint_add_integer_min(abac_condition_t *cond,int val);
+extern void abac_constraint_add_integer_target(abac_condition_t *cond,int val);
+extern void abac_constraint_add_float_max(abac_condition_t *cond,float val);
+extern void abac_constraint_add_float_min(abac_condition_t *cond,float val);
+extern void abac_constraint_add_float_target(abac_condition_t *cond,float val);
+extern void abac_constraint_add_time_max(abac_condition_t *cond,char* val);
+extern void abac_constraint_add_time_min(abac_condition_t *cond,char* val);
+extern void abac_constraint_add_time_target(abac_condition_t *cond,char* val);
+extern void abac_constraint_add_urn_target(abac_condition_t *cond,char* val);
+extern void abac_constraint_add_string_target(abac_condition_t *cond,char* val);
+extern void abac_constraint_add_boolean_target(abac_condition_t *cond, char* val);
+extern abac_condition_t *abac_constraint_from_role(abac_aspect_t *ptr);
+extern abac_condition_t *abac_constraint_create(char *vtype);
+extern abac_condition_t *abac_constraint_from_oset(abac_aspect_t *ptr);
+extern char *abac_constraint_typed_string(abac_condition_t *ptr);
+extern char *abac_constraint_string(abac_condition_t *ptr);
+extern abac_aspect_t *abac_role_principal_create(char *principal_name);
+extern abac_aspect_t *abac_oset_principal_create(char *principal_name);
+extern abac_aspect_t *abac_oset_create(char *principal_name, char *oset_name);
+extern abac_aspect_t *abac_role_create(char *principal_name, char *role_name);
+extern abac_aspect_t *abac_oset_linked_create(char *principal_name, char *linked_role_name, char *oset_name);
+extern abac_aspect_t *abac_role_linked_create(char *principal_name, char *linked_role_name, char *role_name);
+extern abac_aspect_t *abac_oset_object_create(abac_term_t *object);
+extern int abac_oset_is_object(abac_aspect_t *ptr);
+extern int abac_oset_is_principal(abac_aspect_t *ptr);
+extern int abac_role_is_principal(abac_aspect_t *ptr);
+extern int abac_oset_is_linking(abac_aspect_t *ptr);
+extern int abac_role_is_linking(abac_aspect_t *ptr);
+extern char *abac_role_linked_role(abac_aspect_t *ptr);
+extern char *abac_oset_linked_role(abac_aspect_t *ptr);
+extern char *abac_role_name(abac_aspect_t *ptr);
+extern char *abac_oset_name(abac_aspect_t *ptr);
+extern char *abac_role_principal(abac_aspect_t *ptr);
+extern char *abac_oset_principal(abac_aspect_t *ptr);
+extern void abac_role_add_data_term(abac_aspect_t *ptr, abac_term_t *param);
+extern void abac_oset_add_data_term(abac_aspect_t *ptr, abac_term_t *param);
+extern void abac_role_add_linked_data_term(abac_aspect_t *ptr, abac_term_t *param);
+extern void abac_oset_add_linked_data_term(abac_aspect_t *ptr, abac_term_t *param);
+extern char *abac_oset_object(abac_aspect_t *ptr);
+extern char *abac_oset_typed_string(abac_aspect_t *ptr);
+extern char *abac_oset_string(abac_aspect_t *ptr);
+extern char *abac_role_typed_string(abac_aspect_t *ptr);
+extern char *abac_role_string(abac_aspect_t *ptr);
+extern abac_term_t **abac_oset_get_data_terms(abac_aspect_t *ptr);
+extern abac_term_t **abac_oset_get_linked_data_terms(abac_aspect_t *ptr);
+extern abac_term_t **abac_role_get_data_terms(abac_aspect_t *ptr);
+extern abac_term_t **abac_role_get_linked_data_terms(abac_aspect_t *ptr);
+extern void abac_id_write_cert_fname(abac_id_t *ptr,char *filename);
+extern void abac_id_write_privkey_fname(abac_id_t *ptr,char *filename);
+extern int abac_id_load_encrypted_privkey_file(abac_id_t *ptr, char *filename, char *pfile);
+extern char *abac_head_string(abac_attribute_t *ptr);
+extern char *abac_tail_string(abac_attribute_t *ptr);
+extern char *abac_head_typed_string(abac_attribute_t *ptr);
+extern char *abac_tail_typed_string(abac_attribute_t *ptr);
+extern void abac_attribute_write_cert_fname(abac_attribute_t *ptr,char *filename);
+extern abac_aspect_t **abac_attribute_role_tails(abac_attribute_t *ptr);
+extern abac_aspect_t **abac_attribute_oset_tails(abac_attribute_t *ptr);
+extern int abac_context_load_id(abac_context_t *ptr, abac_id_t *id);
+extern int abac_context_load_id_idkey_file(abac_context_t *ptr, char *filename);
+extern int abac_context_load_id_files(abac_context_t *ptr, char *filename, char *keyfilename);
+extern int abac_context_load_attribute(abac_context_t *ptr, abac_attribute_t *attr);
+extern int abac_context_load_encrypted_id_file(abac_context_t *ptr, char *filename, char *pfile);
+extern int abac_context_load_encrypted_id_files(abac_context_t *ptr, char *filename, char *keyfilename, char *pfile);
+
+#endif /* __ABAC_C_H__ */
